#version 450

//attribute
layout (location = 0) in vec4 a_position;
layout (location = 1) in uvec4 a_color;

//varying
layout (location = 1) out vec2 v_texcoord;
layout (location = 2) out vec4 v_diffuse;

//uniform
layout (push_constant) uniform PushConsts {
    vec4 u_viewport;
} pushConsts;

float inverseWeight = 1.0/255.0;

void main()
{
    v_texcoord = a_position.zw;
    v_diffuse = a_color * inverseWeight;
//    v_diffuse = vec4(uvec4(a_color)) * inverseWeight;
//    v_diffuse = (255.0 + a_color * sign(a_color));
//    v_diffuse = min(v_diffuse * inverseWeight, 1.0);
    
    gl_Position.x = a_position.x * 2.0 / pushConsts.u_viewport.z - 1.0;
    gl_Position.y = (1.0 - a_position.y / pushConsts.u_viewport.w) * 2.0 - 1.0;

    gl_Position.z = 0.0;
    gl_Position.w = 1.0;
    gl_Position.z = (gl_Position.z + gl_Position.w) / 2.0;
}
